﻿using cn.com.chinabank.CBSecurity;
using NetSoftok.DBUtility;
using System;
using System.Data.SqlClient;
namespace NetSoftok.Web.chinabank
{
    public partial class Receive : System.Web.UI.Page
    {


        public string sql = string.Empty;     //公司SQL字符
        protected string v_oid;		// 订单号
        protected string v_pstatus;	// 支付状态码
        //20（支付成功，对使用实时银行卡进行扣款的订单）；
        //30（支付失败，对使用实时银行卡进行扣款的订单）；

        protected string v_pstring;	//支付状态描述
        protected string v_pmode;	//支付银行
        protected string v_md5info;	//MD5校验码
        protected string v_amount;	//支付金额
        protected string v_moneytype;	//币种		
        protected string remark1;	// 备注1
        protected string remark2;	// 备注1
        protected string v_md5str;
        protected string status_msg;
        //提现
        protected string falg;     //提现状态
        protected string userid;   //提现用户ID
        private void Page_Load(object sender, System.EventArgs e)
        {
            string userKey = string.Empty;
            string userParter = string.Empty;
            string cmd = "SELECT * FROM MT_PayOnLine where pay_Name='网银在线'";

            try
            {
                using (SqlDataReader dr = SqlHelper.ExecuteReader(cmd))
                {
                    while (dr.Read())
                    {
                        userKey = dr["pay_MiYao"].ToString();
                        userParter = dr["pay_ZhangHao"].ToString();
                    }
                }
            }
            catch (Exception ex)
            {
                Response.Write("查询网银信息时出错！");
            }
            // MD5密钥要跟订单提交页相同，如Send.asp里的 key = "test" ,修改""号内 test 为您的密钥
            string key = userKey;	// 如果您还没有设置MD5密钥请登陆我们为您提供商户后台，地址：https://merchant3.chinabank.com.cn/
            // 登陆后在上面的导航栏里可能找到“资料管理”，在资料管理的二级导航栏里有“MD5密钥设置”
            // 建议您设置一个16位以上的密钥或更高，密钥最多64位，但设置16位已经足够了

            v_oid = Request["v_oid"];
            v_pstatus = Request["v_pstatus"];
            v_pstring = Request["v_pstring"];
            v_pmode = Request["v_pmode"];
            v_md5str = Request["v_md5str"];
            v_amount = Request["v_amount"];
            v_moneytype = Request["v_moneytype"];
            remark1 = Request["remark1"];
            remark2 = Request["remark2"];

            string str = v_oid + v_pstatus + v_amount + v_moneytype + key;
            bool isValidMD5Code = MD5Util.verifyMD5(str, v_md5str);

            if (isValidMD5Code)
            {
                status_msg = "ok";

                if (v_pstatus.Equals("20"))
                {
                    //支付成功
                    //在这里商户可以写上自己的业务逻辑
                    sql = "update MT_Cart set cart_IsPay=1 where cart_ID='" + v_oid + "'";
                    SqlHelper.ExecuteNonQuery(sql);
                    Response.Write("success");
                    //SystemLable.GetSysInfo();
                    //using (SqlDataReader dr = SqlHelper.ExecuteReader("select cart_Amount,cart_UID from MT_Cart where cart_ID=" +v_oid))
                    //{
                    //    while (dr.Read())
                    //    {

                    //        SqlHelper.ExecuteNonQuery("update MT_User set score=score+" + SystemLable.Getmoneytype(Convert.ToDouble(dr[0]), SystemLable.webmoneyper) + " where u_ID=" + Util.GetStringToInt32(dr[1].ToString()) + " );

                    //    }
                    //}
                }
                else if (v_pstatus.Equals("30"))
                {
                    Response.Write("fail");
                }
            }
            else
            {
                status_msg = "error";
            }
        }
    }
}