﻿using System;
using NetSoftok.TemplateAction;
using System.Data.SqlClient;
using NetSoftok.DBUtility;
using tenpay;
using System.Configuration;
using System.Data;
using NetSoftok.BLL;

namespace NetSoftok.Web.tenpay
{
    public partial class md5_pay :System.Web.UI.Page
    {
        protected void Page_Load(object sender, System.EventArgs e)
        {
            Config web = new Config();
            NetSoftok.Model.Config _obj = web.GetConfig(1);
            //商户号
            string bargainor_id =string.Empty;

            //密钥
            string key = string.Empty;
            string cmd = "SELECT pay_PrentID,pay_ZhangHao FROM MT_PayOnLine where pay_Name='财付通' ";
            try
            {
                using (SqlDataReader dr = SqlHelper.ExecuteReader(cmd))
                {
                    while (dr.Read())
                    {
                        key = dr[1].ToString();
                        bargainor_id = dr[2].ToString();
                    }
                }
            }
            catch (Exception ex)
            {
                Response.Write("查询财付通时出错！" + ex.Message);
            }
           
            //当前时间 yyyyMMdd
            string date = DateTime.Now.ToString("yyyyMMdd");

            //生成订单10位序列号，此处用时间和随机数生成，商户根据自己调整，保证唯一
            //string strReq = "" + DateTime.Now.ToString("HHmmss") + TenpayUtil.BuildRandomStr(4);
            int CX_id = 0;    //订单ID
            if (!string.IsNullOrEmpty(Request["v_oid"]))
            {
                CX_id = Util.GetStringToInt32(Request["v_oid"]);
            }
            if (CX_id <= 0)
            {
                webconfigpage.Show_Msg("参数无效！");
            }
            string strReq = string.Empty;
            using (SqlDataReader sdr = SqlHelper.ExecuteReader("select cart_OrderNo from MT_Cart where cart_ID=" + Util.GetStringToInt32(Request["v_oid"])))
             {
                 while (sdr.Read())
                 {
                     strReq = sdr[0].ToString();
                 }
             }
            string sign = string.Empty;
            try
            {
                using (SqlDataReader dr1 = SqlHelper.ExecuteReader(SqlHelper.ConnectionStringLocalTransaction, CommandType.Text, "select o_ID,o_PID,o_PName from MT_Order where o_CartID='" + CX_id + "'", null))
                {
                    while (dr1.Read())
                    {
                        sign += "<a title='" + dr1[2].ToString() + "' href='" + _obj.WebUrl + "/Product/ProInfo.aspx?id=" + dr1[1].ToString() + "&classid=" + Convert.ToInt32(SqlHelper.ExecuteScalar("select top 1 classID from MT_Pro where id=" + dr1[1].ToString())) + "'>" + Util.GetSomeString(dr1[2].ToString(), 8) + "</a>|";

                    }
                }
            }
            catch { }
            //商户订单号，不超过32位，财付通只做记录，不保证唯一性
            string sp_billno = strReq;

            //财付通订单号，10位商户号+8位日期+10位序列号，需保证全局唯一
            string transaction_id = bargainor_id + date + sp_billno;
            string return_url = "http://" +Request.Url.Host.ToString() + ConfigurationSettings.AppSettings["show_url"];

            //创建PayRequestHandler实例
            PayRequestHandler reqHandler = new PayRequestHandler(Context);

            //设置密钥
            reqHandler.setKey(key);

            //初始化
            reqHandler.init();

            //-----------------------------
            //设置支付参数
            //-----------------------------
            reqHandler.setParameter("bargainor_id", bargainor_id);			//商户号
            reqHandler.setParameter("sp_billno", sp_billno);				//商家订单号
            reqHandler.setParameter("transaction_id", transaction_id);		//财付通交易单号
            reqHandler.setParameter("return_url", return_url);				//支付通知url
            reqHandler.setParameter("desc", "订单号：" + transaction_id);	//商品名称
            reqHandler.setParameter("sign", "订单商品:" + sign);	//备注
            reqHandler.setParameter("total_fee",  Util.ClearUnSafeString(Request["v_amount"]));						//商品金额,以分为单位




            //用户ip,测试环境时不要加这个ip参数，正式环境再加此参数
            //reqHandler.setParameter("spbill_create_ip",Page.Request.UserHostAddress);

            //获取请求带参数的url
            string requestUrl = reqHandler.getRequestURL();
            Response.Redirect(requestUrl);

            //post实现方式
            /*
            reqHandler.getRequestURL();
            Response.Write("<form method=\"post\" action=\""+ reqHandler.getGateUrl() + "\" >\n");
            Hashtable ht = reqHandler.getAllParameters();
            foreach(DictionaryEntry de in ht) 
            {
                Response.Write("<input type=\"hidden\" name=\"" + de.Key + "\" value=\"" + de.Value + "\" >\n");
            }
            Response.Write("<input type=\"submit\" value=\"财付通支付\" >\n</form>\n");
            */

            //获取debug信息
            //string debuginfo = reqHandler.getDebugInfo();
            //Response.Write("<br/>" + debuginfo + "<br/>");

            //重定向到财付通支付
            //reqHandler.doSend();

        }

        #region Web 窗体设计器生成的代码
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: 该调用是 ASP.NET Web 窗体设计器所必需的。
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        /// 设计器支持所需的方法 - 不要使用代码编辑器修改
        /// 此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {

        }
        #endregion
        //protected System.Web.UI.WebControls.Label labErrmsg;
        //protected System.Web.UI.WebControls.Button btPay;
        //Md5Pay md5pay = new Md5Pay();

        //int userid = 0, ruserid = 0;
        //private void Page_Load(object sender, System.EventArgs e)
        //{
        //    // 在此处放置用户代码以初始化页面

        //    int CX_id = 0;    //订单ID
        //    if (!string.IsNullOrEmpty(Request["v_oid"]))
        //    {
        //        CX_id = Util.GetStringToInt32(Request["v_oid"]);
        //    }
        //    if (CX_id <= 0)
        //    {
        //        webconfigpage.Show_Msg("参数无效！");
        //    }
        //    #region---交易详细
        //    //查询用户订单
        //    using (SqlDataReader sdr = SqlHelper.ExecuteReader("select * from MT_Cart where cart_ID=" + Util.GetStringToInt32(Request["v_oid"])))
        //    {
        //        while (sdr.Read())
        //        {
        //            md5pay.Mch_name = sdr["suser"].ToString();//买家名称
        //            md5pay.Date = DateTime.Now.ToString("yyyyMMdd");
        //            //商品总价商品价格（分为单位） 
        //            md5pay.Mch_price = Convert.ToDouble(Util.ClearUnSafeString(Request["v_amount"]));

        //            md5pay.Transport_desc = "见网站详细";//收货附言
        //            md5pay.Transport_fee = 0;//货运费
        //            md5pay.Mch_desc = sdr["cart_Des"].ToString();//交易说明
        //            md5pay.Need_buyerinfo = 2;//是否需要在财付通填定物流信息，1：需要，2：不需要
        //            md5pay.Mch_type = 1;//交易类型：1、实物交易，2、虚拟交易
        //            md5pay.Mch_vno = sdr["cart_OrderNo"].ToString();//商家的定单号
        //            md5pay.Attach = "CreateIdeal";
        //            userid = Util.GetStringToInt32(sdr["cart_UID"].ToString());//卖家
        //            ruserid = Util.GetStringToInt32(sdr["cart_UID"].ToString());
        //        }
        //    }
        //    #endregion
        //    #region---财付通商号
        //    string cmd = "SELECT * FROM MT_PayOnLine where pay_Name='财付通' ";
        //    try
        //    {
        //        using (SqlDataReader dr = SqlHelper.ExecuteReader(cmd))
        //        {
        //            while (dr.Read())
        //            {
        //                md5pay.Key = dr["pay_MiYao"].ToString();
        //                md5pay.Chnid = dr["pay_ZhangHao"].ToString();
        //            }
        //        }
        //    }
        //    catch (Exception ex)
        //    {
        //        Response.Write("查询财付通时出错！" + ex.Message);
        //    }
        //    //using (SqlDataReader udr = SqlHelper.ExecuteReader("select top 1 cftpartner  from CX_Onlinepayment where  CX_userid=" + userid))
        //    //{
        //    //    while (udr.Read())
        //    //    {
        //    //        md5pay.Seller = udr[0].ToString();
        //    //    }
        //    //}

        //    #endregion
        //    string url = "";
        //    if (!md5pay.GetPayUrl(out url))
        //    {
        //        webconfigpage.Show_Msg(Server.HtmlEncode(url));
        //    }
        //    else
        //    {
        //        /*在这里可以把
        //         * 交易单号			md5pay.Transaction_id
        //         * 商户订单号		md5pay.Sp_billno
        //         * 订单金额			md5pay.Total_fee
        //         * 等信息记入数据库.
        //         * */

        //        Response.Redirect(url);
        //    }
        //}

        //#region Web 窗体设计器生成的代码
        //override protected void OnInit(EventArgs e)
        //{
        //    //
        //    // CODEGEN: 该调用是 ASP.NET Web 窗体设计器所必需的。
        //    //
        //    InitializeComponent();
        //    base.OnInit(e);
        //}

        ///// <summary>
        ///// 设计器支持所需的方法 - 不要使用代码编辑器修改
        ///// 此方法的内容。
        ///// </summary>
        //private void InitializeComponent()
        //{
        //    this.Load += new System.EventHandler(this.Page_Load);
        //}
        //#endregion
    }
}
