﻿using System;
using System.Data;
using System.Text;
using System.Security.Cryptography;
using System.Collections.Specialized;
using System.IO;
using System.Data.SqlClient;
using System.Net;
using NetSoftok.DBUtility;
using NetSoftok.TemplateAction;

namespace NetSoftok.Web.Alipays
{
    public partial class Alipay_Return :System.Web.UI.Page
    {
        /// <summary>
        /// created by sunzhizhi 2006.5.21,sunzhizhi@msn.com。
        /// </summary>
        ///
        public  string retstr =string.Empty;
        public static string GetMD5(string s, string _input_charset)
        {
            /// <summary>
            /// 与ASP兼容的MD5加密算法
            /// </summary>

            MD5 md5 = new MD5CryptoServiceProvider();
            byte[] t = md5.ComputeHash(Encoding.GetEncoding(_input_charset).GetBytes(s));
            StringBuilder sb = new StringBuilder(32);
            for (int i = 0; i < t.Length; i++)
            {
                sb.Append(t[i].ToString("x").PadLeft(2, '0'));
            }
            return sb.ToString();
        }

        public static string[] BubbleSort(string[] r)
        {
            /// <summary>
            /// 冒泡排序法
            /// </summary>

            int i, j; //交换标志 
            string temp;

            bool exchange;

            for (i = 0; i < r.Length; i++) //最多做R.Length-1趟排序 
            {
                exchange = false; //本趟排序开始前，交换标志应为假

                for (j = r.Length - 2; j >= i; j--)
                {
                    if (System.String.CompareOrdinal(r[j + 1], r[j]) < 0)　//交换条件
                    {
                        temp = r[j + 1];
                        r[j + 1] = r[j];
                        r[j] = temp;

                        exchange = true; //发生了交换，故将交换标志置为真 
                    }
                }

                if (!exchange) //本趟排序未发生交换，提前终止算法 
                {
                    break;
                }

            }
            return r;
        }
        //获取远程服务器ATN结果
        public String Get_Http(String a_strUrl, int timeout)
        {
            string strResult;
            try
            {
                HttpWebRequest myReq = (HttpWebRequest)HttpWebRequest.Create(a_strUrl);
                myReq.Timeout = timeout;
                HttpWebResponse HttpWResp = (HttpWebResponse)myReq.GetResponse();
                Stream myStream = HttpWResp.GetResponseStream();
                StreamReader sr = new StreamReader(myStream, Encoding.Default);
                StringBuilder strBuilder = new StringBuilder();
                while (-1 != sr.Peek())
                {
                    strBuilder.Append(sr.ReadLine());
                }
                strResult = strBuilder.ToString();
            }
            catch (Exception exp)
            {
                strResult = "错误：" + exp.Message;
            }
            return strResult;
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            /// <summary>
            /// created by sunzhizhi 2006.5.21,sunzhizhi@msn.com。
            /// </summary>
            ///当不知道https的时候，请使用http
            //string alipayNotifyURL = "https://www.alipay.com/cooperate/gateway.do?";
            string alipayNotifyURL = "http://notify.alipay.com/trade/notify_query.do?";

            string _input_charset = "utf-8";
            string partner =string.Empty; 		//partner
            string key =string.Empty; //安全校验码 

            try
            {
                using (SqlDataReader dr = SqlHelper.ExecuteReader(SqlHelper.ConnectionStringLocalTransaction, CommandType.Text, "select pay_PrentID,pay_ZhangHao from MT_PayOnLine where pay_ID=3", null))
                {
                    while (dr.Read())
                    {
                        partner = dr[0].ToString();
                        key = dr[1].ToString();
                    }
                }
            }
            catch { }

            //alipayNotifyURL = alipayNotifyURL + "service=notify_verify" + "&partner=" + partner + "&notify_id=" + Request.QueryString["notify_id"];
            alipayNotifyURL = alipayNotifyURL + "&partner=" + partner + "&notify_id=" + Request.QueryString["notify_id"];

            string responseTxt = Get_Http(alipayNotifyURL, 120000);
            //*********************************************************************************************
            int i;
            NameValueCollection coll;
            //Load Form variables into NameValueCollection variable.
            coll = Request.QueryString;

            // Get names of all forms into a string array.
            String[] requestarr = coll.AllKeys;



            //进行排序；
            string[] Sortedstr = BubbleSort(requestarr);

            //构造待md5摘要字符串 ；

            StringBuilder prestr = new StringBuilder();

            for (i = 0; i < Sortedstr.Length; i++)
            {
                if (Sortedstr[i] != "sign" && Sortedstr[i] != "sign_type")
                {
                    if (i == Sortedstr.Length - 1)
                    {
                        prestr.Append(Sortedstr[i] + "=" + Request.QueryString[Sortedstr[i]]);

                    }
                    else
                    {

                        prestr.Append(Sortedstr[i] + "=" + Request.QueryString[Sortedstr[i]] + "&");
                    }
                }
            }

            prestr.Append(key);

            //生成Md5摘要；
            string mysign = GetMD5(prestr.ToString(), _input_charset);


            string sign = Request.QueryString["sign"];

            string out_trade_no=Util.ClearUnSafeString(Request["out_trade_no"]);   

            if (mysign == sign && responseTxt == "true")   //验证支付发过来的消息，签名是否正确
            {
                if (Request.Form["trade_status"] == "WAIT_SELLER_SEND_GOODS" || Request.Form["trade_status"] == "TRADE_FINISHED" || Request.Form["trade_status"] == "TRADE_SUCCESS")
                {
                    string sql = "update MT_Cart set cart_IsPay=1 where cart_OrderNo='" + out_trade_no + "' and isfa=0";
                    SqlHelper.ExecuteNonQuery(sql);
                    //SystemLable.GetSysInfo();
                    //using (SqlDataReader dr = SqlHelper.ExecuteReader("select cart_Amount,cart_UID from MT_Cart where cart_OrderNo='" + out_trade_no + "' and webconfig="+webid))
                    //{
                    //    while (dr.Read())
                    //    {

                    //        SqlHelper.ExecuteNonQuery("update MT_User set score=score+" + SystemLable.Getmoneytype(Convert.ToDouble(dr[0]), SystemLable.webmoneyper) + " where u_ID=" + Util.GetStringToInt32(dr[1].ToString()) + " );

                    //    }
                    //}
                    //更新自己数据库的订单语句，请自己填写一下
                    //    //向客户发送email信息
                    //    //获取客户email
                    //    string cusemail="";
                    //    string serveremail="";
                    //    string serversmtp="";
                    //    string serverpwd=""; 
                    //    try{
                    //    using(SqlDataReader drc=SqlHelper.ExecuteReader(SqlHelper.ConnectionStringLocalTransaction,CommandType.Text,"select u_Email from MT_User where u_ID=(select cart_UID from MT_Cart where cart_OrderNo='"+out_trade_no+"')",null)){
                    //        while(drc.Read())
                    //        {
                    //          cusemail=drc[0].ToString();
                    //        }
                    //        }              

                    //    }
                    //    catch{}
                    //    //-----
                    //    //获取发送端信息
                    //     try{
                    //    using(SqlDataReader drs=SqlHelper.ExecuteReader(SqlHelper.ConnectionStringLocalTransaction,CommandType.Text,"select  top 1 emailsmtp,emailpwd,webAdminEmail  from MT_Config",null))
                    //    {
                    //        while(drs.Read())
                    //        {
                    //          serveremail=drs[2].ToString();
                    //            serversmtp=drs[0].ToString();
                    //            serverpwd=drs[1].ToString();
                    //        }
                    //   }

                    //    }
                    //    catch{}


                    //    //---------------
                    //    if(!string.IsNullOrEmpty(cusemail) && !string.IsNullOrEmpty(serveremail) && !string.IsNullOrEmpty(serversmtp) && !string.IsNullOrEmpty(serverpwd))
                    //    {
                    //       //发送者email 用户名
                    //        string servername="";
                    //        try
                    //        {
                    //            int startnum=serveremail.IndexOf("@");
                    //            servername = serveremail.Substring(0, startnum);

                    //        }
                    //        catch { }


                    //        //----------
                    //        string title="<font style='size:16px;font-weight:bold'>恭喜你！使用支付宝购物在线支付成功！</font>";
                    //        string body="<table border='0' cellpadding='2' cellspacing='2' align='cener' width='98%'><tr><td height='30'><font style='font-size:14px'>支付宝购物在线支付成功通知</font></td></tr><tr><td height='40' align='center'>你好！你在<font color='red'>"+HttpContext.Current.Application["webName"].ToString()+"</font>的购物订单：<font color='red'>"+out_trade_no+"</font>在线支付成功！</td></tr></table> ";
                    //NetSoftok.Common.SendEmail.Send(serveremail,servername,serverpwd,serversmtp,cusemail,title,body);
                    //    }

                    //Response.Write("success");     //返回给支付宝消息，成功
                    //Response.Write("<br>------------------" + Request.QueryString["body"]);
                    retstr = "支付宝在线支付成功！";
                }             
            }
            else
            {
                //Response.Write("fail");
                //Response.Write("<br>------------------" + Request.QueryString["body"]);
                retstr = "支付宝在线支付失败！";
            }
        }
    }
}