﻿using System;
using System.Data.SqlClient;
using NetSoftok.TemplateAction;
using NetSoftok.DBUtility;
using tenpay;
using NetSoftok.BLL;

namespace NetSoftok.Web.tenpay
{
    public partial class paynotify :System.Web.UI.Page
    {
        protected void Page_Load(object sender, System.EventArgs e)
        {
            Config web = new Config();
            NetSoftok.Model.Config _obj = web.GetConfig(1);
            //密钥
            string key = string.Empty;
            string cmd = "SELECT pay_PrentID FROM MT_PayOnLine where pay_Name='财付通' ";
            try
            {
                using (SqlDataReader dr = SqlHelper.ExecuteReader(cmd))
                {
                    while (dr.Read())
                    {
                        key = dr[1].ToString();
                    }
                }
            }
            catch (Exception ex)
            {
                Response.Write("查询财付通时出错！" + ex.Message);
            }
            //创建PayResponseHandler实例
            PayResponseHandler resHandler = new PayResponseHandler(Context);

            resHandler.setKey(key);

            //判断签名
            if (resHandler.isTenpaySign())
            {
                //交易单号
                string transaction_id = resHandler.getParameter("transaction_id");
                //订单号
                string sp_billno = resHandler.getParameter("sp_billno");
                //金额金额,以分为单位
                string total_fee = resHandler.getParameter("total_fee");

                //支付结果
                string pay_result = resHandler.getParameter("pay_result");

                if ("0".Equals(pay_result))
                {
                    //买家付款成功，注意判断订单是否重复的逻辑
                  string sql = "update MT_Cart set cart_IsPay=1 where cart_OrderNo='" + Util.ClearUnSafeString(sp_billno) + "' ";
                    SqlHelper.ExecuteNonQuery(sql);
                    SystemLable.GetSysInfo();
                    using (SqlDataReader dr = SqlHelper.ExecuteReader("select cart_Amount,cart_UID from MT_Cart where cart_OrderNo='" + Util.ClearUnSafeString(sp_billno) + "'"))
                    {
                        while (dr.Read())
                        {

                            SqlHelper.ExecuteNonQuery("update MT_User set score=score+" + SystemLable.Getmoneytype(Convert.ToDouble(dr[0]), SystemLable.webmoneyper) + " where u_ID=" + Util.GetStringToInt32(dr[1].ToString()));

                        }
                    }

                    //调用doShow, 打印meta值跟js代码,告诉财付通处理成功,并在用户浏览器显示$show页面.
                    resHandler.doShow("http://" + _obj.WebUrl + "/tenpay/show.aspx");
                }
                else
                {
                    //当做不成功处理
                    Response.Write("支付失败");
                }

            }
            else
            {
                Response.Write("认证签名失败");
                //string debugInfo = resHandler.getDebugInfo();
                //Response.Write("<br/>debugInfo:" + debugInfo);
            }


        }

        #region Web 窗体设计器生成的代码
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: 该调用是 ASP.NET Web 窗体设计器所必需的。
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        /// 设计器支持所需的方法 - 不要使用代码编辑器修改
        /// 此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {

        }
        #endregion
        //string sql =string.Empty;
        //private void Page_Load(object sender, System.EventArgs e)
        //{
        //    if (!IsPostBack)
        //    {
        //        //出于安全考虑,可以校验一下请求URL的机器是否为财付通服务器.
        //        string errmsg =string.Empty;

        //        Md5Pay md5pay = new Md5Pay();

        //        if (!md5pay.GetPayValueFromUrl(Request.QueryString, out errmsg))
        //        {
        //            //认证签名失败
        //            Response.Write(errmsg + "<br/>");
        //        }
        //        else
        //        {
        //            //认证签名成功
        //            Response.Write("retcode:" + md5pay.Retcode + "<br/>");
        //            //返回码判断
        //            if (md5pay.Retcode == 0)
        //            {
        //                Response.Write("status:" + md5pay.Status + "<br/>");

        //                //按状态处理相关业务逻辑
        //                switch (Int32.Parse(md5pay.Status))
        //                {
        //                    case 1:
        //                        //交易创建
        //                        break;
        //                    case 2:
        //                        //收获地址填写完毕
        //                        break;
        //                    case 3:
        //                        //买家付款成功，注意判断订单是否重复的逻辑
        //                        sql = "update MT_Cart set cart_IsPay=1 where cart_OrderNo='" + Util.ClearUnSafeString(md5pay.Mch_vno) + "' ";
        //                        SqlHelper.ExecuteNonQuery(sql);
        //                        SystemLable.GetSysInfo();
        //                        using (SqlDataReader dr = SqlHelper.ExecuteReader("select cart_Amount,cart_UID from MT_Cart where cart_OrderNo='" + Util.ClearUnSafeString(md5pay.Mch_vno) + "'"))
        //                        {
        //                            while (dr.Read())
        //                            {

        //                                SqlHelper.ExecuteNonQuery("update MT_User set score=score+" + SystemLable.Getmoneytype(Convert.ToDouble(dr[0]), SystemLable.webmoneyper) + " where u_ID=" + Util.GetStringToInt32(dr[1].ToString()));

        //                            }
        //                        }
        //                        break;
        //                    case 4:
        //                        //卖家发货成功
        //                        sql = "update MT_Cart set isfa=1 where cart_OrderNo='" + Util.ClearUnSafeString(md5pay.Mch_vno) + "'";
        //                        SqlHelper.ExecuteNonQuery(sql);
        //                        break;
        //                    case 5:
        //                        //买家收货确认，交易成功
        //                        sql = "update MT_Cart set isfa=2 where cart_OrderNo='" + Util.ClearUnSafeString(md5pay.Mch_vno) + "'";
        //                        SqlHelper.ExecuteNonQuery(sql);
        //                        break;
        //                    case 7:
        //                        //修改交易价格成功
        //                        break;
        //                    case 8:
        //                        //买家发起退款
        //                        break;
        //                    case 9:
        //                        //退款成功
        //                        break;
        //                    case 10:
        //                        //退款关闭
        //                        break;
        //                    default:
        //                        //error	
        //                        break;
        //                }
        //            }
        //            else
        //            {
        //                //失败，请不要按成功处理
        //            }
        //        }

        //    }
        //}

        //#region Web 窗体设计器生成的代码
        //override protected void OnInit(EventArgs e)
        //{
        //    //
        //    // CODEGEN: 该调用是 ASP.NET Web 窗体设计器所必需的。
        //    //
        //    InitializeComponent();
        //    base.OnInit(e);
        //}

        ///// <summary>
        ///// 设计器支持所需的方法 - 不要使用代码编辑器修改
        ///// 此方法的内容。
        ///// </summary>
        //private void InitializeComponent()
        //{
        //    this.Load += new System.EventHandler(this.Page_Load);

        //}
        //#endregion
    }
}
